﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Threading;

namespace SendImageBytes
{
    class Program
    {
        static void Main(string[] args)
        {

            //发送二进制流 突然想到两种方式

            //1. 自己实现 对端口的监听 以及SOCKET封装


            //2. 使用http.sys 注册服务

            try
            {
                using (HttpListener listerner = new HttpListener())
                {
                    listerner.AuthenticationSchemes = AuthenticationSchemes.Anonymous;//指定身份验证 Anonymous匿名访问
                    listerner.Prefixes.Add("http://+/");
                    listerner.Prefixes.Add("http://+:8080/");
                    listerner.Prefixes.Add("http://+/video.cgi/");
                    listerner.Prefixes.Add("http://+:8080/video.cgi/");
                    listerner.Start();
                    Console.WriteLine("WebServer Start Successed.......");
                    while (true)
                    {
                        try
                        {
                            //等待请求连接
                            //没有请求则GetContext处于阻塞状态
                            HttpListenerContext ctx = listerner.GetContext();
                            ctx.Response.StatusCode = 200;//设置返回给客服端http状态代码
                            string name = ctx.Request.QueryString["name"];

                            if (name != null)
                            {
                                Console.WriteLine(name);
                            }


                            //使用Writer输出http响应代码
                            using (StreamWriter writer = new StreamWriter(ctx.Response.OutputStream))
                            {
                                Console.WriteLine("hello");
                                writer.WriteLine("<html><head><title>The WebServer Test</title></head><body>");
                                writer.WriteLine("<div style=\"height:20px;color:blue;text-align:center;\"><p> hello {0}</p></div>", name);
                                writer.WriteLine("<ul>");

                                foreach (string header in ctx.Request.Headers.Keys)
                                {
                                    writer.WriteLine("<li><b>{0}:</b>{1}</li>", header, ctx.Request.Headers[header]);
                                    writer.Flush();
                                }

                                for (int i = 0, l = 5; i < l; i++)
                                {
                                    writer.WriteLine("<li><b>{0}:</b>{1}</li>", i, i);
                                    Console.WriteLine("<li><b>{0}:</b>{1}</li>", i, i);
                                    writer.Flush();
                                    Thread.Sleep(200);
                                }
                                writer.WriteLine("</ul>");
                                writer.WriteLine("</body></html>");


                                writer.Close();
                                ctx.Response.Close();
                            }
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine(ex);
                        }
                    }
                    listerner.Stop();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);

            }

            Console.ReadKey();

        }
    }
}
